Index: trunk/lib/PEdit.inc.php
===================================================================
--- trunk/lib/PEdit.inc.php	(revision 124)
+++ trunk/lib/PEdit.inc.php	(revision 136)
@@ -1,5 +1,8 @@
 <?php
 /**
- * PEdit:: provides a mechanism to store text in php variables
+ * PEdit.inc.php
+ * code by strangecode :: www.strangecode.com :: this document contains copyrighted information
+ *
+ * PEdit provides a mechanism to store text in php variables
  * which will be printed to the client browser under normal
  * circumstances, but an authenticated user can 'edit' the document--
@@ -11,5 +14,11 @@
  * To use, include this file, initialize variables,
  * and call printing/editing functions where you want data and forms to
- * show up. Below is an example of use:
+ * show up.
+ * 
+ * @author  Quinn Comendant <quinn@strangecode.com>
+ * @concept Beau Smith <beau@beausmith.com>
+ * @version 2.0 
+ * 
+ * Example of use:
  
  // Initialize PEdit object.
@@ -37,7 +46,4 @@
  $pedit->formEnd();
 
- * @author  Quinn Comendant <quinn@strangecode.com>
- * @concept Beau Smith <beau@beausmith.com>
- * @version 2.0
  */
 class PEdit {
@@ -95,9 +101,11 @@
     function setParam($params)
     {
+		$app =& App::getInstance();
+
         if (isset($params) && is_array($params)) {
             // Merge new parameters with old overriding only those passed.
             $this->_params = array_merge($this->_params, $params);
         } else {
-            App::logMsg(sprintf('Parameters are not an array: %s', $params), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Parameters are not an array: %s', $params), LOG_WARNING, __FILE__, __LINE__);
         }
     }
@@ -112,8 +120,10 @@
     function getParam($param)
     {
+		$app =& App::getInstance();
+    
         if (isset($this->_params[$param])) {
             return $this->_params[$param];
         } else {
-            App::logMsg(sprintf('Parameter is not set: %s', $param), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Parameter is not set: %s', $param), LOG_NOTICE, __FILE__, __LINE__);
             return null;
         }
@@ -129,4 +139,6 @@
     function start($initialize_data_file=false)
     {
+		$app =& App::getInstance();
+
         if (!is_dir($this->getParam('data_dir'))) {
             trigger_error(sprintf('PEdit data directory not found: %s', $this->getParam('data_dir')), E_USER_WARNING);
@@ -143,15 +155,15 @@
         case 'Save' :
             if ($this->_writeData()) {
-                App::dieURL($_SERVER['PHP_SELF']);
+                $app->dieURL($_SERVER['PHP_SELF']);
             }
             break;
         case 'Restore' :
             if ($this->_restoreVersion(getFormData('version'))) {
-                App::dieURL($_SERVER['PHP_SELF']);
+                $app->dieURL($_SERVER['PHP_SELF']);
             }
             break;
         case 'View' :
             $this->_data_file = sprintf('%s%s__%s.xml', $this->getParam('data_dir'), $_SERVER['PHP_SELF'], getFormData('version'));
-            App::raiseMsg(sprintf(_("This is <em><strong>only a preview</strong></em> of version %s."), getFormData('version')), MSG_NOTICE, __FILE__, __LINE__);
+            $app->raiseMsg(sprintf(_("This is <em><strong>only a preview</strong></em> of version %s."), getFormData('version')), MSG_NOTICE, __FILE__, __LINE__);
             break;
         }
@@ -176,9 +188,11 @@
     function set($name, $options=array())
     {
+		$app =& App::getInstance();
+
         $name = preg_replace('/\s/', '_', $name);
         if (!isset($this->_data[$name])) {
             $this->_data[$name] = array_merge(array('content' => ''), $options);
         } else {
-            App::logMsg(sprintf('Duplicate set data: %s', $name), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Duplicate set data: %s', $name), LOG_NOTICE, __FILE__, __LINE__);
         }
     }
@@ -208,4 +222,6 @@
     function formBegin()
     {
+		$app =& App::getInstance();
+
         if (!$this->_authorized || empty($this->_data)) {
             return false;
@@ -216,5 +232,5 @@
         <input type="hidden" name="file_hash" value="<?php echo $this->_fileHash(); ?>" />
         <?php
-        App::printHiddenSession();
+        $app->printHiddenSession();
         switch ($this->op) {
         case 'Edit' :
@@ -345,4 +361,6 @@
     function printVersions()
     {
+		$app =& App::getInstance();
+
         if ($this->_authorized && $this->op == 'Versions') {
             // Print versions and commands to view/restore.
@@ -362,8 +380,8 @@
                     ?>
                     <tr>
-                        <td><?php echo date(App::getParam('date_format'), $v['unixtime']); ?></td>
-                        <td><?php echo date(App::getParam('time_format'), $v['unixtime']); ?></td>
+                        <td><?php echo date($app->getParam('date_format'), $v['unixtime']); ?></td>
+                        <td><?php echo date($app->getParam('time_format'), $v['unixtime']); ?></td>
                         <td><?php echo humanFileSize($v['filesize']); ?></td>
-                        <td class="sc-nowrap"><a href="<?php echo App::oHREF($_SERVER['PHP_SELF'] . '?op=View&version=' . $v['unixtime'] . '&file_hash=' . $this->_fileHash()); ?>"><?php echo _("View"); ?></a> <?php echo _("or"); ?> <a href="<?php echo App::oHREF($_SERVER['PHP_SELF'] . '?op=Restore&version=' . $v['unixtime'] . '&file_hash=' . $this->_fileHash()); ?>"><?php echo _("Restore"); ?></a></td>
+                        <td class="sc-nowrap"><a href="<?php echo $app->oHREF($_SERVER['PHP_SELF'] . '?op=View&version=' . $v['unixtime'] . '&file_hash=' . $this->_fileHash()); ?>"><?php echo _("View"); ?></a> <?php echo _("or"); ?> <a href="<?php echo $app->oHREF($_SERVER['PHP_SELF'] . '?op=Restore&version=' . $v['unixtime'] . '&file_hash=' . $this->_fileHash()); ?>"><?php echo _("Restore"); ?></a></td>
                     </tr>
                     <?php
@@ -386,5 +404,7 @@
     function _fileHash()
     {
-        return md5(App::getParam('signing_key') . $_SERVER['PHP_SELF']);
+		$app =& App::getInstance();
+
+        return md5($app->getParam('signing_key') . $_SERVER['PHP_SELF']);
     }
 
@@ -399,7 +419,9 @@
     function _loadDataFile()
     {
+		$app =& App::getInstance();
+
         if (!file_exists($this->_data_file)) {
             if (!$this->_initializeDataFile()) {
-                App::logMsg(sprintf('Initializing content file failed: %s', $this->_data_file), LOG_WARNING, __FILE__, __LINE__);
+                $app->logMsg(sprintf('Initializing content file failed: %s', $this->_data_file), LOG_WARNING, __FILE__, __LINE__);
                 return false;
             }
@@ -408,5 +430,5 @@
         $status = $this->xml_unserializer->unserialize($xml_file_contents, false);    
         if (PEAR::isError($status)) {
-            App::logMsg(sprintf('XML_Unserialize error: %s', $status->getMessage()), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('XML_Unserialize error: %s', $status->getMessage()), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
@@ -436,5 +458,7 @@
     function _initializeDataFile()
     {
-        App::logMsg(sprintf('Initializing data file: %s', $this->_data_file), LOG_INFO, __FILE__, __LINE__);
+		$app =& App::getInstance();
+
+        $app->logMsg(sprintf('Initializing data file: %s', $this->_data_file), LOG_INFO, __FILE__, __LINE__);
         $xml_file_contents = $this->xml_serializer->serialize($this->_data);
         return $this->_filePutContents($this->_data_file, $xml_file_contents);
@@ -450,4 +474,6 @@
     function _writeData()
     {
+		$app =& App::getInstance();
+
         if (!$this->_authorized) {
             return false;
@@ -455,5 +481,5 @@
         if ($this->_fileHash() != getFormData('file_hash')) {
             // Posted data is NOT for this file!
-            App::logMsg(sprintf('File_hash does not match current file.', null), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('File_hash does not match current file.', null), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
@@ -466,5 +492,5 @@
             $this->_deleteOldVersions();
             if (!$this->_createVersion()) {
-                App::logMsg(sprintf('Failed creating new version of file.', null), LOG_NOTICE, __FILE__, __LINE__);
+                $app->logMsg(sprintf('Failed creating new version of file.', null), LOG_NOTICE, __FILE__, __LINE__);
                 return false;
             }
@@ -496,7 +522,9 @@
     function _filePutContents($filename, $content)
     {
+		$app =& App::getInstance();
+
         // Ensure requested filename is within the pedit data dir.
         if (strpos($filename, $this->getParam('data_dir')) === false) {
-            App::logMsg(sprintf('Failed writing file outside pedit _data_dir: %s', $filename), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Failed writing file outside pedit _data_dir: %s', $filename), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -510,5 +538,5 @@
             if (!is_dir($curr_path)) {
                 if (!mkdir($curr_path)) {
-                    App::logMsg(sprintf('Failed mkdir: %s', $curr_path), LOG_ERR, __FILE__, __LINE__);
+                    $app->logMsg(sprintf('Failed mkdir: %s', $curr_path), LOG_ERR, __FILE__, __LINE__);
                     return false;
                 }
@@ -522,13 +550,13 @@
                 flock($fp, LOCK_UN);
             } else {
-                App::logMsg(sprintf('Could not lock file for writing: %s', $filename), LOG_ERR, __FILE__, __LINE__);
+                $app->logMsg(sprintf('Could not lock file for writing: %s', $filename), LOG_ERR, __FILE__, __LINE__);
                 return false;
             }
             fclose($fp);
             // Success!
-            App::logMsg(sprintf('Wrote to file: %s', $filename), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Wrote to file: %s', $filename), LOG_DEBUG, __FILE__, __LINE__);
             return true;
         } else {
-            App::logMsg(sprintf('Could not open file for writing: %s', $filename), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Could not open file for writing: %s', $filename), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -544,4 +572,6 @@
     function _createVersion()
     {
+		$app =& App::getInstance();
+
         if (!$this->_authorized) {
             return false;
@@ -549,5 +579,5 @@
         if ($this->_fileHash() != getFormData('file_hash')) {
             // Posted data is NOT for this file!
-            App::logMsg(sprintf('File_hash does not match current file.', null), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('File_hash does not match current file.', null), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -555,5 +585,5 @@
         // Ensure current data file exists.
         if (!file_exists($this->_data_file)) {
-            App::logMsg(sprintf('Data file does not yet exist: %s', $this->_data_file), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Data file does not yet exist: %s', $this->_data_file), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -563,5 +593,5 @@
         $version_file = sprintf('%s__%s.xml', preg_replace('/\.xml$/', '', $this->_data_file), time());
         if (!copy($this->_data_file, $version_file)) {
-            App::logMsg(sprintf('Failed copying new version: %s -> %s', $this->_data_file, $version_file), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Failed copying new version: %s -> %s', $this->_data_file, $version_file), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -580,4 +610,6 @@
     function _deleteOldVersions()
     {
+		$app =& App::getInstance();
+
         $version_files = $this->_getVersions();
         if (is_array($version_files) && sizeof($version_files) > $this->getParam('versions_min_qty')) {
@@ -590,5 +622,5 @@
                 $del_file = dirname($this->_data_file) . '/' . $oldest['filename'];
                 if (!unlink($del_file)) {
-                    App::logMsg(sprintf('Failed deleting version: %s', $del_file), LOG_ERR, __FILE__, __LINE__);
+                    $app->logMsg(sprintf('Failed deleting version: %s', $del_file), LOG_ERR, __FILE__, __LINE__);
                 }
                 $oldest = array_pop($version_files);
@@ -637,4 +669,6 @@
     function _restoreVersion($version)
     {
+		$app =& App::getInstance();
+
         if (!$this->_authorized) {
             return false;
@@ -646,5 +680,5 @@
         // Ensure specified version exists.
         if (!file_exists($version_file)) {
-            App::logMsg(sprintf('Cannot restore non-existant file: %s', $version_file), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot restore non-existant file: %s', $version_file), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -652,5 +686,5 @@
         // Make certain a version is created.
         if (!$this->_createVersion()) {
-            App::logMsg(sprintf('Failed creating new version of file.', null), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Failed creating new version of file.', null), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -658,10 +692,10 @@
         // Do the actual copy.
         if (!copy($version_file, $this->_data_file)) {
-            App::logMsg(sprintf('Failed copying old version: %s -> %s', $version_file, $this->_data_file), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Failed copying old version: %s -> %s', $version_file, $this->_data_file), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
 
         // Success!
-        App::raiseMsg(sprintf(_("Page has been restored to version %s."), $version), MSG_SUCCESS, __FILE__, __LINE__);
+        $app->raiseMsg(sprintf(_("Page has been restored to version %s."), $version), MSG_SUCCESS, __FILE__, __LINE__);
         return true;
     }
Index: trunk/lib/PageNumbers.inc.php
===================================================================
--- trunk/lib/PageNumbers.inc.php	(revision 124)
+++ trunk/lib/PageNumbers.inc.php	(revision 136)
@@ -4,5 +4,5 @@
  * Code by Strangecode :: www.strangecode.com :: This document contains copyrighted information
  *
- * The PageNumbers:: class provides a common abstracted interface to the
+ * The PageNumbers class provides a common abstracted interface to the
  * multiple pages features. It sets the various numbers needed to display items
  * on a page, and includes functions for working with these numbers.
@@ -72,5 +72,7 @@
     function setPerPage($per_page, $default=25, $save_value=true)
     {
-        // (1) By provided argument, if valid.
+		$prefs =& Prefs::getInstance();
+    
+    	// (1) By provided argument, if valid.
         // (2) By saved preference, if available.
         // (3) Set to default value if provided and valid.
@@ -79,8 +81,8 @@
             $this->_per_page = $per_page;
             if ($save_value) {
-                Prefs::setValue('items_per_page', $this->_per_page, $_SERVER['PHP_SELF']);
-            }
-        } else if ($save_value && Prefs::exists('items_per_page', $_SERVER['PHP_SELF'])) {
-            $this->_per_page = (int)Prefs::getValue('items_per_page', $_SERVER['PHP_SELF']);
+                $prefs->set('items_per_page', $this->_per_page, $_SERVER['PHP_SELF']);
+            }
+        } else if ($save_value && $prefs->exists('items_per_page', $_SERVER['PHP_SELF'])) {
+            $this->_per_page = (int)$prefs->get('items_per_page', $_SERVER['PHP_SELF']);
         } else if (is_numeric($default) && $default > 0) {
             $this->_per_page = $default;
@@ -94,5 +96,7 @@
     function setPageNumber($page_number, $save_value=true)
     {
-        // (1) By provided argument, if valid.
+		$prefs =& Prefs::getInstance();
+    
+    // (1) By provided argument, if valid.
         // (2) By saved preference, if available.
         // (3) Don't change from what was provided at class instantiation.
@@ -105,8 +109,8 @@
             }
             if ($save_value) {
-                Prefs::setValue('page_number', $this->current_page, $_SERVER['PHP_SELF']);
-            }
-        } else if ($save_value && Prefs::exists('page_number', $_SERVER['PHP_SELF'])) {
-            $this->current_page = (int)Prefs::getValue('page_number', $_SERVER['PHP_SELF']);
+                $prefs->set('page_number', $this->current_page, $_SERVER['PHP_SELF']);
+            }
+        } else if ($save_value && $prefs->exists('page_number', $_SERVER['PHP_SELF'])) {
+            $this->current_page = (int)$prefs->get('page_number', $_SERVER['PHP_SELF']);
         }
         $this->set_page_number_initialized = true;
@@ -137,12 +141,14 @@
     function calculate()
     {
+		$app =& App::getInstance();
+
         if (!$this->set_per_page_initialized) {
-            App::logMsg(sprintf('set_per_page not initialized'), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('set_per_page not initialized'), LOG_ERR, __FILE__, __LINE__);
         }
         if (!$this->set_page_number_initialized) {
-            App::logMsg(sprintf('set_page_number not initialized'), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('set_page_number not initialized'), LOG_ERR, __FILE__, __LINE__);
         }
         if (!$this->set_total_items_initialized) {
-            App::logMsg(sprintf('set_total_items not initialized'), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('set_total_items not initialized'), LOG_ERR, __FILE__, __LINE__);
         }
 
@@ -189,8 +195,11 @@
     function getLimitSQL()
     {
+		$app =& App::getInstance();
+		$db =& DB::getInstance();
+
         if (is_numeric($this->first_item) && is_numeric($this->_per_page)) {
-            return ' LIMIT ' . DB::escapeString($this->first_item) . ', ' . DB::escapeString($this->_per_page) . ' ';
-        } else {
-            App::logMsg(sprintf('Could not find SQL to LIMIT by %s %s.', $this->first_item, $this->_per_page), LOG_WARNING, __FILE__, __LINE__);
+            return ' LIMIT ' . $db->escapeString($this->first_item) . ', ' . $db->escapeString($this->_per_page) . ' ';
+        } else {
+            $app->logMsg(sprintf('Could not find SQL to LIMIT by %s %s.', $this->first_item, $this->_per_page), LOG_WARNING, __FILE__, __LINE__);
             return '';
         }
@@ -204,4 +213,6 @@
     function printPerPageLinks($query_key='per_page')
     {
+		$app =& App::getInstance();
+
         $sp = '';
         for ($i=0; $i<sizeof($this->per_page_options); $i++) {
@@ -209,5 +220,5 @@
                 printf('%s<a href="%s">%s</a>',
                     $sp,
-                    App::oHREF($_SERVER['PHP_SELF'] . '?' . $query_key . '=' . $this->per_page_options[$i]),
+                    $app->oHREF($_SERVER['PHP_SELF'] . '?' . $query_key . '=' . $this->per_page_options[$i]),
                     $this->per_page_options[$i]
                 );
@@ -220,5 +231,5 @@
 
     /**
-     * Outputs an App::oHREF compatible url that goes to the page $page_number.
+     * Outputs an $app->oHREF compatible url that goes to the page $page_number.
      * Depends on $this->base_url to build the url onto. This is used in the
      * page_number.ihtml template.
@@ -232,5 +243,7 @@
     function getPageNumURL($page_number, $carry_args=null)
     {
-        return App::oHREF($this->url_base . $page_number, $carry_args);
+		$app =& App::getInstance();
+
+        return $app->oHREF($this->url_base . $page_number, $carry_args);
     }
     function printPageNumURL($page_number, $carry_args=null)
Index: trunk/lib/PageSequence.inc.php
===================================================================
--- trunk/lib/PageSequence.inc.php	(revision 124)
+++ trunk/lib/PageSequence.inc.php	(revision 136)
@@ -4,5 +4,5 @@
  * Code by Strangecode :: www.strangecode.com :: This document contains copyrighted information
  *
- * The PageSequence:: class provides an interface to simplify the creation of a multi-step form.
+ * The PageSequence class provides an interface to simplify the creation of a multi-step form.
  *
  * @requires  This class requires Prefs.inc.php
@@ -133,4 +133,6 @@
     function setCurrent($step_id)
     {
+		$app =& App::getInstance();
+
         if (false !== ($pos = $this->getPosition($step_id))) {
             // Specified step exists (even if numeric).
@@ -138,5 +140,5 @@
         } else {
             // Step with specified key does not exist.
-            App::logMsg(sprintf(_("Step %s not defined in sequence %s"), $step_id, $this->sequence_title), LOG_INFO, __FILE__, __LINE__);
+            $app->logMsg(sprintf(_("Step %s not defined in sequence %s"), $step_id, $this->sequence_title), LOG_INFO, __FILE__, __LINE__);
             return false;
         }
@@ -257,7 +259,9 @@
     function printEditLink($step_id=null)
     {
+		$app =& App::getInstance();
+
         $pos = isset($step_id) ? $this->getPosition($step_id) : $this->getPosition();
         if ($_SESSION[$this->seq]['steps'][$pos]['editable']) {
-            printf('[<a href="%s">%s</a>]', App::oHREF($_SERVER['PHP_SELF'] . '?step=' . $pos . '&boomerang=confirmation'), _("edit"));
+            printf('[<a href="%s">%s</a>]', $app->oHREF($_SERVER['PHP_SELF'] . '?step=' . $pos . '&boomerang=confirmation'), _("edit"));
         }
     }
@@ -320,9 +324,11 @@
     function _auto_timeout()
     {
+		$app =& App::getInstance();
+
         if (isset($_SESSION[$this->seq]['last_access_time'])
         && $_SESSION[$this->seq]['last_access_time'] < time() - $this->idle_timeout) {
             // Session has expired, flush all vars to start over.
             $this->startOver();
-            App::dieURL($this->start_url);
+            $app->dieURL($this->start_url);
         } else {
             // Set timer.
Index: trunk/lib/PayPal.inc.php
===================================================================
--- trunk/lib/PayPal.inc.php	(revision 124)
+++ trunk/lib/PayPal.inc.php	(revision 136)
@@ -1,5 +1,8 @@
 <?php
 /**
- * The PayPal:: class provides functions for creating PayPal buttons and for
+ * PayPal.inc.php
+ * code by strangecode :: www.strangecode.com :: this document contains copyrighted information
+ *
+ * The PayPal class provides functions for creating PayPal buttons and for
  * receiving PayPal's Instant Payment Notification (IPN) service.
  *
@@ -74,6 +77,8 @@
     function setButtonDefaults($type, $options)
     {
+		$app =& App::getInstance();
+
         if (!is_array($options) || empty($options)) {
-            App::logMsg(sprintf('Invalid options: %s', getDump($options)), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Invalid options: %s', getDump($options)), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
@@ -82,5 +87,5 @@
             $this->_default_button_options['_global'] = array_merge($this->_default_button_options['_global'], $options);
         } else if (!isset($this->_default_button_options[$type])) {
-            App::logMsg(sprintf('Invalid button type: %s', $type), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Invalid button type: %s', $type), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
@@ -104,16 +109,18 @@
     function newButton($type, $name, $options=null)
     {
+		$app =& App::getInstance();
+
         if (!isset($this->_default_button_options[$type])) {
-            App::logMsg(sprintf('Invalid button type: %s', $type), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Invalid button type: %s', $type), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
 
         if (!is_array($options) || empty($options)) {
-            App::logMsg(sprintf('Invalid options: %s', getDump($options)), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Invalid options: %s', getDump($options)), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
 
         if (isset($this->_buttons[$name])) {
-            App::logMsg(sprintf('Overwriting existing button name: %s', getDump($this->_buttons[$name])), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Overwriting existing button name: %s', getDump($this->_buttons[$name])), LOG_DEBUG, __FILE__, __LINE__);
         }
 
@@ -137,6 +144,8 @@
     function getLink($name)
     {
+		$app =& App::getInstance();
+
         if (!isset($this->_buttons[$name])) {
-            App::logMsg(sprintf('Button does not exist: %s', $name), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Button does not exist: %s', $name), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
@@ -207,9 +216,11 @@
     function setParam($params)
     {
+		$app =& App::getInstance();
+
         if (isset($params) && is_array($params)) {
             // Merge new parameters with old overriding only those passed.
             $this->_params = array_merge($this->_params, $params);
         } else {
-            App::logMsg(sprintf('Parameters are not an array: %s', $params), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Parameters are not an array: %s', $params), LOG_ERR, __FILE__, __LINE__);
         }
     }
@@ -224,8 +235,10 @@
     function getParam($param)
     {
+		$app =& App::getInstance();
+    
         if (isset($this->_params[$param])) {
             return $this->_params[$param];
         } else {
-            App::logMsg(sprintf('Parameter is not set: %s', $param), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Parameter is not set: %s', $param), LOG_NOTICE, __FILE__, __LINE__);
             return null;
         }
@@ -259,9 +272,11 @@
     function processIPN()
     {
+		$app =& App::getInstance();
+
         if (getPost('test_ipn') == '1' || $this->getParam('test_mode')) {
-            App::logMsg(sprintf('Processing PayPal IPN in test mode: %s', getDump(getFormData())), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Processing PayPal IPN in test mode: %s', getDump(getFormData())), LOG_DEBUG, __FILE__, __LINE__);
             $url = parse_url('https://www.sandbox.paypal.com/cgi-bin/webscr');
         } else {
-            App::logMsg(sprintf('Processing PayPal IPN: %s', getDump(getFormData())), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Processing PayPal IPN: %s', getDump(getFormData())), LOG_DEBUG, __FILE__, __LINE__);
             $url = parse_url($this->getParam('paypal_url'));
         }
@@ -287,5 +302,5 @@
 
         if (!$fp) {
-            App::logMsg(sprintf('Connection to PayPal URL %s failed with error: %s (%s)', $ssl . $url['host'], $errstr, $errnum), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Connection to PayPal URL %s failed with error: %s (%s)', $ssl . $url['host'], $errstr, $errnum), LOG_WARNING, __FILE__, __LINE__);
             return false;
         } else {
@@ -304,5 +319,5 @@
             fclose($fp);
 
-            App::logMsg(sprintf('IPN response received: %s', $this->_ipn_response), LOG_NOTICE, __FILE__, __LINE__);
+            $app->logMsg(sprintf('IPN response received: %s', $this->_ipn_response), LOG_NOTICE, __FILE__, __LINE__);
             return true;
         }
@@ -318,22 +333,24 @@
     function verifiedIPN()
     {
+		$app =& App::getInstance();
+
         if (!isset($this->_ipn_response)) {
-            App::logMsg(sprintf('Cannot verify IPN, response not received.', null), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot verify IPN, response not received.', null), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
 
         if (empty($this->_ipn_response)) {
-            App::logMsg(sprintf('Cannot verify IPN, response empty.', null), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Cannot verify IPN, response empty.', null), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
 
         if (preg_match('/VERIFIED/', $this->_ipn_response)) {
-            App::logMsg(sprintf('IPN verified!', null), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('IPN verified!', null), LOG_DEBUG, __FILE__, __LINE__);
             return true;
         } else if (preg_match('/INVALID/', $this->_ipn_response)) {
-            App::logMsg(sprintf('IPN invalid.', null), LOG_DEBUG, __FILE__, __LINE__);
-            return false;
-        } else {
-            App::logMsg(sprintf('IPN unknown.', null), LOG_WARNING, __FILE__, __LINE__);
+            $app->logMsg(sprintf('IPN invalid.', null), LOG_DEBUG, __FILE__, __LINE__);
+            return false;
+        } else {
+            $app->logMsg(sprintf('IPN unknown.', null), LOG_WARNING, __FILE__, __LINE__);
             return false;
         }
